mpz_t *
decrypt(mpz_t * const mpzIn_p, SecKey const sk, int const no_of_blocks)
{
    int i;
    mpz_t *mpzOut_p;

    mpzOut_p = (mpz_t *) malloc(no_of_blocks * sizeof (mpz_t));
    if (mpzOut_p == NULL)
        return (mpzOut_p);

    for (i = 0; i < no_of_blocks; i++)
        mpz_init(mpzOut_p[i]);

    for (i = 0; i < no_of_blocks; i++) {
        mpz_powm(mpzOut_p[i], mpzIn_p[2*i], sk.a, sk.p);
        mpz_invert(mpzOut_p[i], mpzOut_p[i], sk.p);
        mpz_mul(mpzOut_p[i], mpzOut_p[i], mpzIn_p[2*i+1]);
        mpz_mod(mpzOut_p[i], mpzOut_p[i], sk.p);
    }

    return mpzOut_p;
}
